% Head h*(r*,z*) and Stokes stream function psi*(r*,z*)
%**************************************************
tic
clc, clear all
Bi=8;           % Bi [-]
RR=10;          % R* [-]
N_r=101;        % # of nodes in r-direction
N_z=21;         % # of nodes in z-direction
epsilon=0.0000001 % tolerance of series convergence
N_lambda=2000; % number of roots to compute upfront
% arrays of results
h=zeros(N_z,N_r); %head h*(r*,z*)
S=h; Snorm=S;          % stream function psi*(r*,z*) and normalized stream function
N_iter=h;%arrays: head h*(r*,z*), , number of terms in sums
r=linspace(0.1,RR, N_r);
z=linspace(0,1,N_z);
lambR=feigR03(N_lambda,Bi*RR); %script to calculate product lambda(n)x R* , not just lambda(n)
for i=1:N_z
    z_i=z(i); %in terms H and S, 1-z_1 is replaced by z_i for plotting purposes 
    for j=1:N_r
         r_j=r(j);
         Head=0;
         Strf=0;
             for n=1:N_lambda
                pR=lambR(n);
                lambda_n=pR/RR;
                BH_n=2*besselj(1,pR)/(pR*((besselj(0,pR))^2+(besselj(1,pR))^2));
                termH=BH_n*cosh(lambda_n*z_i)/cosh(lambda_n)*besselj(0,lambda_n*r_j);
                BS_n=2*besselj(1,pR)/(pR*((besselj(0,pR))^2+(besselj(1,pR))^2));
                termS=BS_n*sinh(lambda_n*z_i)/cosh(lambda_n)*besselj(1,lambda_n*r_j)*r_j;
                Head=Head+termH; % head summation
                Strf=Strf+termS; % stream function summation
                  if abs(termH/Head) < epsilon
                      break
                  end 
%                  Strf=Strf+termS; 
%                   if (termS/Strf)< epsilon
%                       break
%                   end
             end % n-summation
        h(i,j)=Head; S(i,j)=Strf;
        N_iter(i,j)=n;
    end
end
h; %heads
Smax=max(max(S)), Snorm=S/Smax; % normalized Stokes stream function 
N_iter; %printout of head and number of iterations, element-by-element
[zz,rr]=meshgrid(r,z);
contour (zz,rr,h,10) %note the height instead of depth
% colorbar
hold on
contour (zz,rr,Snorm,10)
colorbar
hold off
xlabel('r* [-], scale equal to z-axis scale'); ylabel('z* [-]'); 
title ('Dimensionless head h*(r*,z*) and Stokes streamfunction Psi*(r*,z*)')
toc
